state("EmuHawk")
{
    int menuLayer : "mgba.dll", 0x000C4050, 0x10, 0x30, 0x654;  // 8 after level completion, 28 if cut scene after level
    int menuLR : "mgba.dll", 0x000C4050, 0x10, 0x30, 0xB04;
    int level : "mgba.dll", 0x000C4050, 0x10, 0x30, 0x54; // x * 265 == level (1st Level is 0)
    int levelStatus : "mgba.dll", 0x000C4050, 0x10, 0x30, 0x14DC;
}


init
{
    vars.episode1Any = false;
    vars.episode1All = false;
    vars.episode2Any = false;
    vars.episode2All = false;
    vars.episode3Any = false;
    vars.episode3All = false;
    vars.episode4Any = false;
    vars.episode4All = false;
    vars.episode5Any = false;
    vars.episode5All = false;
    vars.episode6Any = false;
    vars.episode6All = false;
    vars.episode7Any = false;
    vars.episode7All = false;

    vars.bossFight = 134697300;
    vars.noBossEnd = 134697432;

    vars.episode17 = 6 * 256;
    vars.episode18 = 7 * 256;
    vars.episode27 = 14 * 256;
    vars.episode28 = 15 * 256;
    vars.episode37 = 22 * 256;
    vars.episode38 = 23 * 256;
    vars.episode47 = 30 * 256;
    vars.episode48 = 31 * 256;
    vars.episode57 = 38 * 256;
    vars.episode58 = 39 * 256;
    vars.episode67 = 46 * 256;
    vars.episode68 = 47 * 256;
    vars.episode77 = 54 * 256;
    vars.episode78 = 55 * 256;
    vars.category = "";
}


start
{
    if (old.menuLayer == 25 && current.menuLayer == 27 && old.menuLR == 1 && current.menuLR == 1)
    {
        vars.episode1Any = false;
        vars.episode1All = false;
        vars.episode2Any = false;
        vars.episode2All = false;
        vars.episode3Any = false;
        vars.episode3All = false;
        vars.episode4Any = false;
        vars.episode4All = false;
        vars.episode5Any = false;
        vars.episode5All = false;
        vars.episode6Any = false;
        vars.episode6All = false;
        vars.episode7Any = false;
        vars.episode7All = false;

        if(timer.Run.CategoryName.ToLower().Contains("any%"))
        {
            vars.category = "any%";
        }
        else if(timer.Run.CategoryName.ToLower().Contains("all levels"))
        {
            vars.category = "all levels";
        }
        return true;
    }
}

reset
{
    if (old.menuLayer == 25 && current.menuLayer == 27 && old.menuLR == 1 && current.menuLR == 1)
    {
        vars.episode1Any = false;
        vars.episode1All = false;
        vars.episode2Any = false;
        vars.episode2All = false;
        vars.episode3Any = false;
        vars.episode3All = false;
        vars.episode4Any = false;
        vars.episode4All = false;
        vars.episode5Any = false;
        vars.episode5All = false;
        vars.episode6Any = false;
        vars.episode6All = false;
        vars.episode7Any = false;
        vars.episode7All = false;

        if(timer.Run.CategoryName.ToLower().Contains("any%"))
        {
            vars.category = "any%";
        }
        else if(timer.Run.CategoryName.ToLower().Contains("all levels"))
        {
            vars.category = "all levels";
        }
        return true;
    }
}

split
{
    if(vars.category == "any%")
    {
        if(!vars.episode1Any && current.level == vars.episode17 && current.levelStatus == vars.bossFight && current.menuLayer == 28)
        {
            vars.episode1Any = true;
            return true;
        }

        else if (!vars.episode2Any && current.level == vars.episode27 && current.levelStatus == vars.noBossEnd && current.menuLayer == 28)
        {
            vars.episode2Any = true;
            return true;
        }

        else if (!vars.episode3Any && current.level == vars.episode37 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode3Any = true;
            return true;
        }

        else if (!vars.episode4Any && current.level == vars.episode47 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode4Any = true;
            return true;
        }

        else if (!vars.episode5Any && current.level == vars.episode57 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode5Any = true;
            return true;
        }

        else if(!vars.episode6Any && current.level == vars.episode67 && current.levelStatus == vars.bossFight && current.menuLayer == 28)
        {
            vars.episode6Any = true;
            return true;
        }

        else if(!vars.episode7Any && current.level == vars.episode77 && current.levelStatus == vars.bossFight && current.menuLayer == 28)
        {
            vars.episode7Any = true;
            return true;
        }

    }

    if(vars.category == "all levels")
    {
        if (!vars.episode1All && current.level == vars.episode18 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode1All = true;
            return true;
        }
        else if (!vars.episode2All && current.level == vars.episode28 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode2All = true;
            return true;
        }
        else if (!vars.episode3All && current.level == vars.episode38 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode3All = true;
            return true;
        }
        else if (!vars.episode4All && current.level == vars.episode48 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode4All = true;
            return true;
        }
        else if (!vars.episode5All && current.level == vars.episode58 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode5All = true;
            return true;
        }
        else if (!vars.episode6All && current.level == vars.episode68 && current.levelStatus == vars.noBossEnd && current.menuLayer == 8)
        {
            vars.episode6All = true;
            return true;
        }
        else if (!vars.episode7All && current.level == vars.episode78 && current.levelStatus == vars.noBossEnd && current.menuLayer == 28)
        {
            vars.episode7All = true;
            return true;
        }
    }
}
